package main

import (
	"fmt"
	"sync"
)

func main() {
	p := sync.Pool{
		New: func() interface{} {
			fmt.Println("call new")
			return 1
		},
	}

	// 从池里获取一个
	x := p.Get()
	fmt.Printf("%T %#v\n", x, x)

	// 放回池
	p.Put(x)

	// 再次从池里获取，不调用新建
	x = p.Get()
	fmt.Printf("%T %#v\n", x, x)

	// 在调用会创建，池里已经没有了，会重新创建
	x = p.Get()
	fmt.Printf("%T %#v\n", x, x)

	// Output:
	//call new
	//int 1
	//int 1
	//call new
	//int 1
}
